#include "module.h"

void PaintWnd(WndInfo *w,HDC hdc)
{
#ifdef NO_SKIN
	Rectangle(hdc,0,0,w->Size.cx,w->Size.cy);
#else
  if (!w->emSkin.Bitmap)
  {
	  Rectangle(hdc,0,0,w->Size.cx,w->Size.cy);
  }
  else
  {
    HDC src = CreateCompatibleDC(hdc);
    HGDIOBJ hbmOld = SelectObject(src,w->emSkin.Bitmap);
    RECT rDest;
    SetRect(&rDest,0,0,w->Size.cx,w->Size.cy);
    LSTransEdgeBlt(hdc,&rDest,src,&w->emSkin,FALSE);
    SelectObject(src,hbmOld);
    DeleteDC(src);
  }
#endif /* NO_SKIN */ 

  /* draw stuff on top of that here */ 
}



void RedrawWnd(WndInfo *w)
{
	ASSERT(w!=NULL);

	HDC hdcScreen,hdcWnd;
	hdcScreen = GetDC(w->hWnd);
	hdcWnd = CreateCompatibleDC(hdcScreen);

	if (w->hbmBackBuffer==NULL)
		w->hbmBackBuffer = CreateCompatibleBitmap(hdcScreen,w->Size.cx,w->Size.cy);

	HBITMAP hbmOld;
	hbmOld = (HBITMAP)SelectObject(hdcWnd,w->hbmBackBuffer);

  /* If it's a layered window (bTrueAlpha) then we can't  */ 
  /* switch back to using regular paint methods with an   */ 
  /* alpha value of 255 without destroying and recreating */ 
  /* the window, so keep using UpdateLayeredWindow.       */ 

	if ((w->Alpha<255 || w->bTrueAlpha) && dAlphaBlend!=NULL)
	{
		BLENDFUNCTION bl;
		bl.BlendOp = AC_SRC_OVER;
		bl.BlendFlags = 0;
		bl.SourceConstantAlpha = (BYTE)w->Alpha;
		bl.AlphaFormat = 0; /* no per-pixel alpha? */ 

		if (!w->bTrueAlpha)
		{
			HDC hdcAlpha = CreateCompatibleDC(hdcScreen);
			HBITMAP hbmAlpha = CreateCompatibleBitmap(hdcScreen,w->Size.cx,w->Size.cy);
			hbmAlpha = (HBITMAP)SelectObject(hdcAlpha,hbmAlpha);

			RECT area;
			GetWindowRect(w->hWnd,&area);
			LSPaintDesktop(hdcWnd,0,0,w->Size.cx,w->Size.cy,area.left,area.top);

			PaintWnd(w,hdcAlpha);

			dAlphaBlend(hdcWnd, 0, 0, w->Size.cx, w->Size.cy, hdcAlpha, 0, 0, w->Size.cx, w->Size.cy, bl);

			hbmAlpha = (HBITMAP)SelectObject(hdcAlpha,hbmAlpha);
			DeleteObject(hbmAlpha);
			DeleteDC(hdcAlpha);

			SelectObject(hdcWnd,hbmOld);
			DeleteDC(hdcWnd);

			InvalidateRect(w->hWnd,NULL,FALSE);
		}
		else
		{
			PaintWnd(w,hdcWnd);

			POINT ptSRC = {0,0};
			POINT p;
			p.x = w->Pos.x; p.y = w->Pos.y;
			ASSERT(sizeof(int)==sizeof(long));
			/* not sure why we always do this for layered windows */ 
			/* probably something weird about parents for them    */ 
			LSConvertCoords(w->Monitor,true,(int *)&p.x,(int *)&p.y);
			dUpdateLayeredWindow(w->hWnd,
				NULL,&p,&w->Size,
				hdcWnd,&ptSRC,
				RGB(255,0,255),&bl,0|ULW_ALPHA|ULW_COLORKEY);

			SelectObject(hdcWnd,hbmOld);
			DeleteDC(hdcWnd);
		}
	}
	else
	{
		PaintWnd(w,hdcWnd);

		SelectObject(hdcWnd,hbmOld);
		DeleteDC(hdcWnd);
		InvalidateRect(w->hWnd,NULL,FALSE);
	}

	ReleaseDC(w->hWnd,hdcScreen);
}
